/*
**      $VER: LibInit.c 37.32 (2.3.99)
**
**      Library initializers and functions to be called by StartUp.c
**
**      (C) Copyright 1996-99 Andreas R. Kleinert
**      All Rights Reserved.
**
**  $Id: LibInit.c,v 1.1 2002/09/27 20:23:27 nobody Exp $
*/

#include <dopus/modules.h>

// Global pointer to a module's locale information
extern struct DOpusLocale *locale;
void init_locale_data(struct DOpusLocale *);

// You MUST define the ModuleInfo structure yourself
extern ModuleInfo module_info;
extern ModuleFunction module_func;


#include <proto/exec.h>
#ifndef CLIB_EXEC_PROTOS_H
#include <clib/exec_protos.h>
#include <pragma/exec_lib.h>
#endif

#ifndef EXEC_MEMORY_H
#include <exec/memory.h>
#endif

#ifndef CLIB_LOCALE_PROTOS_H
#include <clib/locale_protos.h>
#include <pragma/locale_lib.h>
#endif

#include <proto/xadmaster.h>



#define __USE_SYSBASE        // perhaps only recognized by SAS/C

#include <exec/types.h>
#include <exec/memory.h>
#include <exec/libraries.h>
#include <exec/execbase.h>
#include <exec/resident.h>
#include <exec/initializers.h>

#include <proto/exec.h>
#include "compiler.h"

extern __saveds __asm ModuleInfo* Module_Identify(register __d0 int num);
extern int __asm __saveds Module_Entry(register __a0 char *args,	register __a1 struct Screen *screen,
	register __a2 IPCData *ipc,
	register __a3 IPCData *main_ipc,
	register __d0 ULONG mod_id,
	register __d1 EXT_FUNC(func_callback));
extern ULONG __asm __saveds ProgressHook(register __a0 struct Hook *hook, register __a1 struct xadProgressInfo *xpi);


ULONG __saveds __stdargs L_OpenLibs(struct ModuleBase *ModuleBase);
void  __saveds __stdargs L_CloseLibs(void);

struct DosLibrary *DOSBase = NULL;
struct Library *DOpusBase = NULL;
struct Library *IntuitionBase = NULL;
struct Library *GfxBase = NULL;
struct Library *IconBase = NULL;
struct Library *LocaleBase = NULL; 
struct Library *UtilityBase = NULL;
struct Library *LayersBase = NULL;
struct Library *WorkbenchBase = NULL;
struct Library *GadToolsBase = NULL;
struct Library *AslBase = NULL;
struct Library *DiskfontBase = NULL;
struct Library *TimerBase = NULL;
struct Library *RexxSysBase = NULL;
struct xadMasterBase *xadMasterBase = NULL;
struct ExecBase			 *SysBase      = NULL;


struct DOpusLocale *locale;

#define VERSION  1
#define REVISION 23

#define AMLIBNAME "XADopus"
#define AMLIBVER  " 1.23 "DATE

char __aligned TrLibName [] = AMLIBNAME ".module";
char __aligned TrLibID   [] = AMLIBNAME AMLIBVER;
char __aligned Copyright [] = "(C)opyright 2000-02 by Mladen Milinkovic, 2002 by AmiS. All rights reserved.";

char __aligned VERSTRING [] = "\0$VER: " AMLIBNAME AMLIBVER;

/* ----------------------------------------------------------------------------------------
   ! ROMTag and Library inilitalization structure:
   !
   ! Below you find the ROMTag, which is the most important "magic" part of a library
   ! (as for any other resident module). You should not need to modify any of the
   ! structures directly, since all the data is referenced from constants from somewhere else.
   !
   ! You may place the ROMTag directly after the LibStart (-> StartUp.c) function as well.
   !
   ! Note, that the data initialization structure may be somewhat redundant - it's
   ! for demonstration purposes.
   !
   ! EndResident can be placed somewhere else - but it must follow the ROMTag and
   ! it must not be placed in a different SECTION.
   ---------------------------------------------------------------------------------------- */

extern ULONG InitTab[];
extern APTR EndResident; /* below */

struct Resident __aligned ROMTag =     /* do not change */
{
 RTC_MATCHWORD,
 &ROMTag,
 &EndResident,
 RTF_AUTOINIT,
 VERSION,
 NT_LIBRARY,
 0,
 &TrLibName[0],
 &TrLibID[0],
 &InitTab[0]
};

APTR EndResident;

struct MyDataInit                      /* do not change */
{
 UWORD ln_Type_Init;      UWORD ln_Type_Offset;      UWORD ln_Type_Content;
 UBYTE ln_Name_Init;      UBYTE ln_Name_Offset;      ULONG ln_Name_Content;
 UWORD lib_Flags_Init;    UWORD lib_Flags_Offset;    UWORD lib_Flags_Content;
 UWORD lib_Version_Init;  UWORD lib_Version_Offset;  UWORD lib_Version_Content;
 UWORD lib_Revision_Init; UWORD lib_Revision_Offset; UWORD lib_Revision_Content;
 UBYTE lib_IdString_Init; UBYTE lib_IdString_Offset; ULONG lib_IdString_Content;
 ULONG ENDMARK;
} DataTab =
#ifdef VBCC
{
        0xe000,8,NT_LIBRARY,
        0x0080,10,(ULONG) &TrLibName[0],
        0xe000,LIBF_SUMUSED|LIBF_CHANGED,
        0xd000,20,VERSION,
        0xd000,22,REVISION,
        0x80,24,(ULONG) &TrLibID[0],
        (ULONG) 0
};
#else
{
 INITBYTE(OFFSET(Node,         ln_Type),      NT_LIBRARY),
 0x80, (UBYTE) OFFSET(Node,    ln_Name),      (ULONG) &TrLibName[0],
 INITBYTE(OFFSET(Library,      lib_Flags),    LIBF_SUMUSED|LIBF_CHANGED),
 INITWORD(OFFSET(Library,      lib_Version),  VERSION),
 INITWORD(OFFSET(Library,      lib_Revision), REVISION),
 0x80, (UBYTE) OFFSET(Library, lib_IdString), (ULONG) &TrLibID[0],
 (ULONG) 0
};
#endif


/* ----------------------------------------------------------------------------------------
   ! L_OpenLibs:
   !
   ! Since this one is called by InitLib, libraries not shareable between Processes or
   ! libraries messing with RamLib (deadlock and crash) may not be opened here.
   !
   ! You may bypass this by calling this function fromout LibOpen, but then you will
   ! have to a) protect it by a semaphore and b) make sure, that libraries are only
   ! opened once (when using global library bases).
   ---------------------------------------------------------------------------------------- */

ULONG __saveds __stdargs L_OpenLibs(struct ModuleBase *ModuleBase)
{
	SysBase = (*((struct ExecBase **) 4));
//	ModuleBase->atb_SysBase       = SysBase;

	// Open other libraries we need
	if(!(DOpusBase=OpenLibrary("dopus5.library",55)) ||
		!(DOSBase = OpenLibrary("dos.library", 37)) ||
		!(IntuitionBase=OpenLibrary("intuition.library",37)) ||
		!(GfxBase=OpenLibrary("graphics.library",37)) ||
		!(IconBase=OpenLibrary("icon.library",37)) ||
		!(LayersBase=OpenLibrary("layers.library",37)) ||
		!(GadToolsBase=OpenLibrary("gadtools.library",37)) ||
		!(AslBase=OpenLibrary("asl.library",37)) ||
		!(DiskfontBase=OpenLibrary("diskfont.library",37)) ||
		!(TimerBase=GetTimerBase()) ||
		!(UtilityBase=OpenLibrary("utility.library",37)) ||
		!(xadMasterBase=(struct xadMasterBase *)OpenLibrary(XADNAME,7))) return 0;

	// Libraries we don't need but want
	WorkbenchBase=OpenLibrary("workbench.library",0);
	RexxSysBase=OpenLibrary("rexxsyslib.library",0);

	// Allocate and open locale data
	if(!(locale=AllocVec(sizeof(struct DOpusLocale),MEMF_CLEAR)))
		return 0;
	init_locale_data(locale);

	// Open locale library
	if(LocaleBase=OpenLibrary("locale.library",38))
	{
		// Initialise catalog
		locale->li_LocaleBase=LocaleBase;
		if(module_info.locale_name)
			locale->li_Catalog=OpenCatalogA(NULL,module_info.locale_name,0);
		locale->li_Locale=OpenLocale(0);
	}

	// Succeeded
	return 1;
}

/* ----------------------------------------------------------------------------------------
   ! L_CloseLibs:
   !
   ! This one by default is called by ExpungeLib, which only can take place once
   ! and thus per definition is single-threaded.
   !
   ! When calling this fromout LibClose instead, you will have to protect it by a
   ! semaphore, since you don't know whether a given CloseLibrary(foobase) may cause a Wait().
   ! Additionally, there should be protection, that a library won't be closed twice.
   ---------------------------------------------------------------------------------------- */

void __saveds __stdargs L_CloseLibs(void)
{
	// Free locale stuff
	if(locale)
	{
		if(LocaleBase)
		{
			CloseLocale(locale->li_Locale);
			CloseCatalog(locale->li_Catalog);
			CloseLibrary(LocaleBase);
		}
		FreeVec(locale);
	}

	// Close libraries
	if(xadMasterBase) CloseLibrary((struct Library *)xadMasterBase);
	if(DOpusBase) CloseLibrary(DOpusBase);
	if(IntuitionBase) CloseLibrary(IntuitionBase);
	if(GfxBase) CloseLibrary(GfxBase);
	if(IconBase) CloseLibrary(IconBase);
	if(LayersBase) CloseLibrary(LayersBase);
	if(UtilityBase) CloseLibrary(UtilityBase);
	if(WorkbenchBase) CloseLibrary(WorkbenchBase);
	if(DiskfontBase) CloseLibrary(DiskfontBase);
	if(RexxSysBase) CloseLibrary(RexxSysBase);
	if(AslBase) CloseLibrary(AslBase);
	if(GadToolsBase) CloseLibrary(GadToolsBase);
	if(DOSBase) CloseLibrary((struct Library *)DOSBase);
	
}

// This routine is called by Opus to find out what the module does
__saveds __asm ModuleInfo* Module_Identify(register __d0 int num)
{
	// Return module information
	if(num == -1)
		return &module_info;

	// Valid function number?
	if(num == 0)
		return (ModuleInfo *)DOpusGetString(locale, module_info.function[0].desc);
	else if(num == 1)
		return (ModuleInfo *)DOpusGetString(locale, module_func.desc);
	else return 0;

//	if(num > module_info.function_count || !(module_info.function[num].desc))
//		return 0;

	// Return function description
//	return (ModuleInfo *)DOpusGetString(locale,module_info.function[num].desc);
}
